 

/**
 *
 * @author Erhan Oztop, 2001-2002 <br>
 * <br>
 * Source code by Erhan Oztop (erhan@atr.co.jp) <br>
 * Copyright August 2002 via <br>
 * University of Southern California Ph.D. publication copyright <br>
 * This class keeps and array of doubles o represent the cell activity of a region. 
*/
public class PCode  {


    static public int  maxDIM=20;// Maximum 20 dimension of encoding!!

    public String layername,layercomment;
    public int layersize,actualsize;
    public int dim;
    public  int[] dimsize=new int[maxDIM];
    public int[] dimpager=new int[maxDIM];   
    public String[] name=new String[maxDIM],comment=new String[maxDIM];
    public double[] min=new double[maxDIM],max=new double[maxDIM],prec=new double[maxDIM];
    public int[]  start=new int[maxDIM],end=new int[maxDIM];
    public double[] var=new double[maxDIM];

    public double[] firing;
    public double[] elig;
    public double[] prob;

    public double[][] synapse;
    int synapseC;

    public PCode() { 
	System.err.println("Encoding(): ERROR! You must call the full constructor!!");
    }
    public PCode(String lname,int lsize,String lcomment)
    {
	dim=0;
	layername=lname;
	layersize=lsize;
	layercomment=lcomment;
	firing=new double[layersize];
	elig  =firing; 
	prob=firing; //new double[layersize];
    }    

    
    public double elementAt(int i0) {
	if (dim==1) return firing[i0];
	System.err.println("Illegal acces to layer:"+layername+" at "+i0+" returning 0");
	return 0;
    }

    public double elementAt(int i1,int i0) {
	if (dim==2) return firing[i1*dimpager[1]+i0];
	System.err.println("Illegal acces to layer:"+layername+" at "+
			   i1+","+i0+
			   " returning 0");
	return 0;
    }
    public double elementAt(int i2,int i1,int i0) {
	if (dim==3) return firing[i2*dimpager[2]+i1*dimpager[1]+i0];
	System.err.println("Illegal acces to layer:"+layername+" at "+
			   i2+","+i1+","+i0+
			   " returning 0");
	return 0;
    }
	
    public double elementAt(int i3,int i2,int i1,int i0) {
	if (dim==4) return firing[i3*dimpager[3]+i2*dimpager[2]+i1*dimpager[1]+i0];
	System.err.println("Illegal acces to layer:"+layername+" at "+
			   i3+","+i2+","+i1+","+i0+
			   " returning 0");
	return 0;
    }

    public double elementAt(int[] i) {
	if (dim==i.length) {
	    int ix=i[0];
	    for (int k=1;k<dim;k++) ix+=i[k]*dimpager[k];
	    return firing[ix];
	}
	System.err.println("Illegal acces to layer:"+layername+" via array idnexing "+
			   " returning 0");
	return 0;
    }

    /* fix as 01 */
 public double[][] getAvgSheet02() {
	if (dim!=3) return null;
	double [][] M=new double[dimsize[2]][dimsize[0]];
	
        for (int i0=0;i0<dimsize[0];i0++)
	for (int i2=0;i2<dimsize[2];i2++) {
	    M[i2][i0]=0;
	    for  (int i1=0;i1<dimsize[1];i1++)
		M[i2][i0] += prob[i2*dimpager[2]+i1*dimpager[1]+i0];
	    }
	return M;
    }
    /** this is OK*/
   public Point3d[] getAdvAvgSheet01(Motor m, int callback) {
	if (dim!=3) return null;
	double [][] M=getAvgSheet01();
	Point3d [] D=new Point3d[(M.length+1)* M[0].length];  // +1 is for nulls
	int k=0;
        
	for  (int i1=0;i1<dimsize[1];i1++) { 
	    for (int i0=0;i0<dimsize[0];i0++) {
		int ix=i1*dimpager[1]+i0*dimpager[0];
		double[] v=pref_value(ix);  // can speed up
		Point3d wr=m.convert(callback,v[0],v[1],v[2]); //
		Point3d planar=m.map2xy(callback,wr,M[i0][i1]);
		D[k++] = planar;
	    }
	    D[k++]=null;
	}
	return D;
   }
    /** this ok */
    public double[][] getAvgSheet01() {
	if (dim!=3) return null;
	double [][] M=new double[dimsize[0]][dimsize[1]];
	for  (int i0=0;i0<dimsize[0];i0++) 
	    for (int i1=0;i1<dimsize[1];i1++) {
		M[i0][i1]=0;
		for (int i2=0;i2<dimsize[2];i2++)
		    M[i0][i1] += prob[i2*dimpager[2]+i1*dimpager[1]+i0*dimpager[0]];
	    }
	return M;
    }

    /** fix as above OKs*/
    public double[][] getSheet01(int i2) {
	if (dim!=3) return null;
	double [][] M=new double[dimsize[0]][dimsize[1]];
        for (int i0=0;i0<dimsize[0];i0++)
	    for  (int i1=0;i1<dimsize[1];i1++)
		M[i1][i0] = prob[i2*dimpager[2]+i1*dimpager[1]+i0];
	return M;
    }

    public void show01(Motor m,int callback) {
	Point3d[] H=getAdvAvgSheet01(m,callback);

	Gplot gp=new Gplot(H,m.getTempPrefix(callback),m.getGplotCommand(callback));
    }

    private int offset(int[] i) {
	if (dim==i.length) {
	    int ix=i[0];
	    for (int k=1;k<dim;k++) ix+=i[k]*dimpager[k];
	    return ix;
	}
System.err.println("Illegal offset call in layer:"+layername+" via array idnexing "+
		   " returning -1");
	return -1;
    }
    
    static final double def_min=0;
    static final double def_max=1;
    static final double def_var=0.5;
    public void addDimension(String name,int size) {
	addDimension(name,def_min,def_max,size,def_var,"");
    }
public void addDimension(String name,double min,double max,int size,
		 double var, String comment)
    {
	if (dim==0) actualsize=size;
	else actualsize*=size;
	if (dim==0) dimpager[dim]=1;
	else dimpager[dim]=dimpager[dim-1]*dimsize[dim-1];
	this.name[dim]=name;
	this.comment[dim]=comment;
	this.min[dim]=min;
	this.max[dim]=max;
	this.dimsize[dim]=size;
	this.var[dim]=var;
	if (size>1)
	    this.prec[dim]=(max-min)/(size-1);
	else  
	    this.prec[dim]=(max-min)/(size);

	dim++;
	//System.err.println("Encoding(7):"+name+" named encoding created.");
	System.out.println("New axis:"+name+" added with size:"+size);
	System.out.println("The actual layer size became:"+actualsize);
	System.out.println("The total # of dimensions became:"+dim);
    }

    /** This defines the distrubtion of preferred values. Currently the distribution is linear*/
    public double[] pref_value(int[] IX) {
	double[] pr=new double[dim];
	for (int i=0;i<dim;i++)
	    pr[i]=prec[i]*(IX[i])+min[i];
	return pr; 
   }

    public double[] pref_value(int lc) {
	return pref_value(decompressIX(lc));
    }


    /** Reads off the vector valued coarse coding. */
    public double[] decode(int C) {
	return decode(decompressIX(C));
    }
    /** Reads off the vector valued coarse coding. */
    /** this is wrong! Have to be local summing! How do you get double peaks workg?*/
    public double[] decode(int[] IX) {
	int ix;
	double[] vsum=new double[dim],tsum=new double[dim];
	//get the preferred values of all components.
	double[] prefs=pref_value(IX);
	
	// for each component (passing over IX]) calculate the weighted activity
	for (int k=0;k<dim;k++) {
	    ix=IX[k]; // save it, we will overwrite
	    vsum[k]=0; tsum[k]=0;
	for (int i=0;i<dimsize[k];i++) {
	    IX[k]=i;
	    double firinglevel=elementAt(IX);
	    vsum[k]+=prefs[k]*firinglevel;
            tsum[k]+=firinglevel;
	}
	if (tsum[k]!=0)
	    vsum[k]/=tsum[k];    // firing may not add up to one, normalize
	IX[k]=ix;  // restore the value
	}
	return vsum;
    }

    private int compressIX(int[] IX) {
	int sum=IX[dim-1];
	for (int i=dim-2;i>=0;i--) sum=sum*dimsize[i]+IX[i];
	return sum;
    }
    
    private int[] decompressIX(int C) {
	int[] IX=new int[dim];
	//System.out.print("Thecompressing "+C+" = [");
	for (int i=dim-1;i>=0;i--) {
	    IX[i]=C/dimpager[i];
	    //System.out.print(IX[i]);
	    C=C%dimpager[i];
	}
	//System.out.println("]");
	return IX;
    }

    public int encode(double[] value, double[] confidence)
    {
	int winner=-1;


	// if out of boundry force to the limits
	for (int i=0;i<dim;i++) {
	    if (value[i]<min[i]) value[i]=min[i];
	    if (value[i]>max[i]) value[i]=max[i];
	}

	// this is our depth variable for loop to run on the dim-hyper cube
	

	//double slotvalue=min;
	double mindis=1e15;
	boolean done=false;
	for (int lc=0;lc<actualsize;lc++) {
	    double[] prefs=pref_value(decompressIX(lc));
	    double diff=0;
	    for (int i=0; i < dim; i++)
		diff+=(prefs[i]-value[i])*(prefs[i]-value[i]);
	    if (diff < mindis)
		{ mindis=diff;  winner=lc;}
	}
   
		
	if (winner==-1) {
	    System.err.println("RCode.encode : ERROR cannot find winner !!! ");
	}
    
	int[] winnerIX=decompressIX(winner);
	/*  // this is not very good because it encodes the value as a plus
            // instead of a ball around the best point  
	
	int[] IX=decompressIX(winner);
	for (int k=0;k<dim;k++) {
	    int ix=IX[k];
	    
	    for (int i=0; i<dimsize[k]; i++) {   
		IX[k]=i;
		setFiring(IX,confidence[k] * Math.exp(-IXdist(IX,winnerIX)/var[k]));
		}
	    setfiring(winnerIX,1.0);
	}
	*/

        // this has to be improved by probably adding the covariance matrix in distance
        // metric. Currently it ignores the variance and makes perfect sphere around the
        // winner instead of a ellipse for example.

	double vr=var[0];  //  see note above
	double cf=confidence[0]; // need to fix this too
	for (int lc=0;lc<actualsize;lc++) {
	    int[] IX=decompressIX(lc);
	    double act=cf * Math.exp(-IXdist(IX,winnerIX)/vr);
	    if (act<0.00001) act=0;
	    setfiring(lc,act);
	}
	return winner;
    }


    /** returns the euclidian distance between the points IX1 and IX2 */
	public double IXdist(int[] IX1, int[] IX2) {
	    double sum=0;
	    for (int i=0;i<dim;i++) sum+=(IX1[i]-IX2[i])*(IX1[i]-IX2[i]);
	    return sum;
	}
    /** returns the euclidian distance between the points [encoded] C1 and C2 */
	public double Cdist(int C1, int C2) {
	    double sum=0;
	    int[] IX1=decompressIX(C1);
	    int[] IX2=decompressIX(C2);
	    for (int i=0;i<dim;i++) sum+=(IX1[i]-IX2[i])*(IX1[i]-IX2[i]);
	    return sum;
	}
     /** returns the euclidian distance between the points  IX1 and [encoded] C2 */
    public double CIXdist(int[] IX1, int C2) {
	    double sum=0;
	    int[] IX2=decompressIX(C2);
	    for (int i=0;i<dim;i++) sum+=(IX1[i]-IX2[i])*(IX1[i]-IX2[i]);
	    return sum;
	}
   /** returns the euclidian distance between the points  IX1 and [encoded] C2 */
    public double CIXdist(int C2,int[] IX1) {
	return CIXdist(IX1,C2);
    }

	public void setfiring(int ix, double val) {
	    firing[ix]=val;
	}

    public void setFiring(int[] IX,double val) {
	int comp=compressIX(IX);
	int off=offset(IX);
	System.out.println("*********** MUST BE THE SAME **********");
	System.out.println(comp+"  =  "+off);
	firing[comp]=val;
    }

    public double getFiring(int[] IX) {
	int C=compressIX(IX);
	return firing[C];
    }


    // elig points to firing these days be careful!!
    public void setTombStone(int C, double ignore) {
	setTombStone(C);
    }
    public void setTombStone(int C) {
	for (int i=0;i<layersize;i++) elig[i]=0;
	elig[C]=1;
	}

    public void setTombStone(int[] addr) {
	int[] a=new int[dim];
	for (int k=0;k<dim;k++) {
	    if (addr[k]>=dimsize[k]) {
		System.out.println(
	    name[k]+" (index "+k+") is beyond dimsize!! Assigning to (dimsize-1):" + 
	    (dimsize[k]-1));
		a[k]=dimsize[k]-1;
	    } else if (addr[k]<0) {
		System.out.println(
	        name[k]+" (index "+k+") is less than zero!! Assigning to it to: 0");
		a[k]=0;
	    } else {
		System.out.println(
	        name[k]+" (index "+k+") is good ("+addr[k]+")");
	        a[k]=addr[k];
	    }
	}

	for (int i=0;i<layersize;i++) elig[i]=0;
	int C=compressIX(a);
	if (C<0) {
	    System.out.println(" IMPOSSIBLE! index less than zero, truncated to zero");
	    C=0;
	} else if (C>=layersize) {
	    System.out.println(
	    " IMPOSSIBLE! index is beyond layersize!! Assigning to " + (layersize-1)+"]");
	    C=layersize-1;
	}
	elig[C]=1;
    }

    public void setGaussBall(int C, double var2) {
	//setTombStone(C);
	//if (1==1) return;
	
	int[] IX=decompressIX(C);
	// double sc=1.0/Math.sqrt(2*Math.PI*var2);
	double sum=0;
	
	for (int i=0;i<layersize;i++) {
	    double d=CIXdist(IX,i);
	    elig[i]=Math.exp(-d*d/(2*var2));
	    sum+=elig[i];
	}
	for (int i=0;i<layersize;i++) elig[i] /= sum;	
    }

    /** Creates howmany multiplicative synapses (cache vectors to be multiplied)*/
    public void makeSynapse(int howmany) {
	synapseC=howmany;
	synapse=new double[howmany][];
	for (int i=0;i<howmany;i++) {
	    synapse[i]=new double[layersize];
	}
    }
    /** Multiply the synaptic probabilities to get the net probability */
    public void mergeSynapse() {
	for (int k=0;k<layersize;k++) {
	    prob[k]=1;
	    for (int i=0;i<synapseC;i++) {
		prob[k]*=synapse[i][k];
	    }
	}
    }

  public static void main(String[] argv)
  {
      PCode p1=new PCode("testLayer",5*10*12,"testing");
      p1.addDimension("X",0,1e4,12,1,"X axis");
      p1.addDimension("Y",0,1e4,10, 1,"Y axis");
      p1.addDimension("Z",0,1e4, 5, 1,"Z axis");
      int[] vect=new int[3];
      for (int x=0;x<12;x++)
	  for (int y=0;y<10;y++) 
	      for (int z=0;z<5;z++) {
		  vect[0]=x; vect[1]=y; vect[2]=z;
		  p1.setFiring(vect,x*y*z);
		  double verify=p1.getFiring(vect);
		  
	      }

      double[] val={7500,2500,5000};
      double[] conf={1,1,1};
      
      for (int x=0;x<12;x++)  
	  for (int y=0;y<10;y++) 
	      for (int z=0;z<5;z++){
		  vect[0]=x; vect[1]=y; vect[2]=z;
		  double v=p1.getFiring(vect);
		  System.out.println(v+" == "+x*y*z);
	      }   
      p1.encode(val,conf);
      for (int i=0;i<p1.actualsize;i++) {
	  System.out.print(p1.firing[i]+"  ");
	  if (i%12==0) System.out.println("       -> X comp end.");
	  if (i%(12*10)==0) System.out.println("     -> Y comp end.");
      }
  } //main
  
    public void setEncodingVar(double v) {
	for (int i=0;i<dim;i++) var[i]=v;
    }

    /** WARNING: only v[0] is used/ need to modify encode/decode stuff!! */
    public void setEncodingVar(double[] v) {
	for (int i=0;i<dim;i++) var[i]=v[i];
    }
} // PCode
/*
 *
 * Erhan Oztop, 2000-2002  <br>
 * Source code by Erhan Oztop (erhan@atr.co.jp) <br>
 * Copyright August 2002 under <br>
 * University of Southern California Ph.D. publication copyright <br>
 */
 
